import { world, system } from "@minecraft/server"

const {
  dataDrivenEntityTriggerEvent
} = world.events

const eventId = "ghost:visible"

system.runInterval(() => {
  for (let player of world.getAllPlayers()) {
    let entity = player.getEntitiesFromViewDirection({ maxDistance: 150 })[0]
    if (entity?.typeId === "sra:scp_2107_ghost" && !entity.moveTag) {
      entity.moveTag = true
      listenTo(entity)
      entity.triggerEvent(eventId)
    }
  }
});

function listenTo(entity) {
  const evId = dataDrivenEntityTriggerEvent.subscribe(data => {
    dataDrivenEntityTriggerEvent.unsubscribe(evId)
    system.runTimeout(() => {
      delete entity.moveTag
      entity.triggerEvent("ghost:invisible")
    }, 1)
  }, { entities: [entity], eventTypes: [eventId] })
};